#ifndef __LOCATION_ICE
#define __LOCATION_ICE

#include <jast/common/Coordinates.ice>
#include <jast/output/Body.ice>

module jast {
    module common {
        enum LocationType {
            User, RobotHand, Table, Assembled, UnknownLocation, AnyLocation
        };

        enum TableArea {
            UserArea, RobotArea, CommonArea, OutsideArea, AnyArea
        };

        /** A big class with redundant fields ... ick ... but may be neater
         * than my previous attempts?
         */
        // Formerly a class -- make sure the C++ mapping doesn't change
        ["cpp:class"]
        struct Location {
            LocationType type;

            // Only when type == Table
            jast::common::TableCoordinates coords;
            TableArea area;

            // Only when type == Robot
            jast::output::Hand robotHand;

            // Only when type == Assembled
            string parentId;
        };
    };
};

#endif // __LOCATION_ICE

