#ifndef SPEECHRECOGNITIONLISTENER_ICE
#define SPEECHRECOGNITIONLISTENER_ICE

#include <Ice/BuiltinSequences.ice>
#include <jast/common/Timestamp.ice>

module jast {
    module listener {
        struct SpeechHypothesis {
            string words;
            double confidence;
        };
        
        ["java:type:java.util.LinkedList<jast.listener.SpeechHypothesis>"]
        sequence<SpeechHypothesis> SpeechHypothesisList;
        
        interface SpeechRecognitionListener {
            void recognizedTurn (string top, ::Ice::StringSeq alternatives,
                    ::jast::common::Timestamp startTime, ::jast::common::Timestamp endTime);
        };
    };
};

#endif // SPEECHRECOGNITIONLISTENER_ICE
